--[[

Define French-language strings and chat message parsing funtion

need codes for special characters: ,,,,
  =#195##160# "..string.char(195)..string.char(160).."
  =#195##161#
  =#195##162# "..string.char(195)..string.char(162).."
  =#195##163#
  =#195##164# "..string.char(195)..string.char(164).."
  =#195##165#
  =#195##166#
  =#195##167# "..string.char(195)..string.char(167).."  (231 for pop-up)
  =#195##168# "..string.char(195)..string.char(168).."  (232 for pop-up)
  =#195##169# "..string.char(195)..string.char(169).."  (233 for pop-up)
  =#195##170# "..string.char(195)..string.char(170).."
  =#195##171#
  =#195##172#
  =#195##173#
  =#195##174# "..string.char(195)..string.char(174).."
  =#195##175#
  =#195##176#
  =#195##177#
  =#195##178#
  =#195##179# '..string.char(195)..string.char(179).."
  =#195##180#
  =#195##181#
  =#195##182#
  =#195##183#
  =#195##184#
  =#195##185# "..string.char(195)..string.char(185).."
  =#195##186# "..string.char(195)..string.char(186).."
  =#195##187# "..string.char(195)..string.char(187).."
  =#195##188# "..string.char(195)..string.char(188).."
  =#195##132# "..string.char(195)..string.char(132).."
  =#195##137#
  =#195##156# "..string.char(195)..string.char(156).."
  =#195##150# "..string.char(195)..string.char(150).."
  =#195##159# "..string.char(195)..string.char(159).."

]]--

_G.L = {};

L["PluginLoaded"] = " "..string.char(195)..string.char(169).."crit par K1R4D3L charg"..string.char(195)..string.char(169);
L["PluginUnloaded"] = " "..string.char(195)..string.char(169).."crit par K1R4D3L d"..string.char(195)..string.char(169).."charg"..string.char(195)..string.char(169);

L["CmdShow"] = "afficher";
L["CmdShowDesc"] = "Affiche la fen"..string.char(195)..string.char(170).."tre principale de KillTracker";
L["Usage"] = "usage";

L["LoadFailure"] = "Impossible de charger le fichier de donn"..string.char(195)..string.char(169).."es. Donn"..string.char(195)..string.char(169).."es ne sauvera pas jusqu\'"..string.char(195)..string.char(160).." ce que le fichier de donn"..string.char(195)..string.char(169).."es est r"..string.char(195)..string.char(169).."par"..string.char(195)..string.char(169).." ou supprim"..string.char(195)..string.char(169).." et "..string.char(195)..string.char(169).."crit est recharg"..string.char(195)..string.char(169).."e.";

L["NoRows"] = "Pas de donn"..string.char(195)..string.char(169).."es "..string.char(195)..string.char(160).." afficher."

L["ShowAllCharacters"] = "Afficher tous les Personnage";

L["NumberSplitChar"] = ".";

L["DirectDamage"] = "D"..string.char(195)..string.char(169).."g"..string.char(195)..string.char(162).."ts au Moral";
L["TrapDamage"] = "D"..string.char(195)..string.char(169).."g"..string.char(195)..string.char(162).."ts de pi"..string.char(195)..string.char(168).."ge";
L["TheTrap"] = "Pi"..string.char(195)..string.char(168).."ge";

L["MobName"] = "Ennemi";
L["CharacterName"] = "Personnage";
L["LevelRange"] = "Niveaux";
L["KillCount"] = "Tu"..string.char(195)..string.char(169);

local function TrimArticles(name)
	return string.gsub(name, '^[Ll].-(%u)', '%1');
end

function L.Parse(line, channel)
  	-- find damage-dealing hits to mobs by character's pets, soldiers and devices
   if (channel == Turbine.ChatType.PlayerCombat) then
      -- only include hits to Morale
      local initiatorName, skillName, targetName, amount = string.match(line, "^(.*) a inflig\195\169 un coup.* avec (.*) sur (.*) pour ([%d,]*) points? de type ?.* \195\160 l\'entit\195\169 ?Moral%.$");
	
      if (initiatorName ~= nil) then
         -- need to handle devices specially because kill messages don't match hit messages
         if (skillName == L.TrapDamage) then
            initiatorName = L.TheTrap;
         else
            initiatorName = TrimArticles(initiatorName);
         end

         -- skip character hits - don't need to use hit-matching for kills by the player directly
         --    if a player names a pet/soldier the same name as their character, this would miss (don't do that)
         if (initiatorName ~= player.name) then
			   targetName = TrimArticles(targetName);

			   amount = string.gsub(amount, ",", "") + 0;

            -- only include damage-dealing hits
            if (amount > 0) then
               return 1, initiatorName, targetName;
            end
         end
      end
   -- find damage-dealing reflects to mobs by character's pets and soldiers
   elseif (channel == Turbine.ChatType.EnemyCombat) then
      -- only include reflects to Morale
      local initiatorName, amount, dmgType, targetName = string.match(line, '^(.*) a renvoy\195\169 ([%d,]*) ?(.*) de d\195\169g\195\162ts au Moral de (.*)%.$');
	
      if ((initiatorName ~= nil) and (dmgType ~= nil)) then
         initiatorName = TrimArticles(initiatorName);

         -- skip character reflects - don't need to use hit-matching for kills by the player directly
         --    if a player names a pet/soldier the same name as their character, this would miss (don't do that)
         if (initiatorName ~= player.name) then
            targetName = TrimArticles(targetName);

            amount = string.gsub(amount, ",", "") + 0;

            if (amount > 0) then
               return 1, initiatorName, targetName;
            end
         end
      end
   -- find mob kills by character and their pets, soldiers and devices
   elseif (channel == Turbine.ChatType.Death) then
      -- mob kills by the character directly
      local targetName = string.match(line, "^Votre coup puissant a vaincu (.*)%.$");

      if (targetName ~= nil) then
         targetName = TrimArticles(targetName);

         -- indicates that hit-matching and in-combat checking is not necessary
         local initiatorName = "$PLAYER$";
	
         return 9, initiatorName, targetName;
      end

      -- mob kills not by the character directly
      local initiatorName, targetName = string.match(line, "^(.*) a vaincu (.*)%.$");

      if (initiatorName ~= nil) then
         -- keeping "The" on special devices to differentiate them
         if (initiatorName ~= L.TheTrap) then
            initiatorName = TrimArticles(initiatorName);
         end

         targetName = TrimArticles(targetName);
	
         return 9, initiatorName, targetName;
      end
   end
end
