--[[

An icon to click on to open the main KillTracker window.

]]--

MinimizedWindow = class(Turbine.UI.Window);

function MinimizedWindow:Constructor()
	Turbine.UI.Window.Constructor(self);
	
	self:SetBackground("K1R4D3L/KillTracker/Resources/logo_up.tga");
	self:SetSize(32, 32);
	self:SetOpacity(.3);
	self:SetPosition(0, Turbine.UI.Display.GetHeight() - 32);
	self:SetVisible(true);

	self.MouseClick = function(sender, args)
		self:SetBackground("K1R4D3L/KillTracker/Resources/logo_up.tga");

		if (self.Moving) then
			self.Moving = false;
			self.MoveX = -1;
		else
			self:SetVisible(false);

			statsWindow:SetVisible(true);

         RefreshKillsDisplay();
		end
	end

	self.MoveX = -1;
	self.MoveY = 0;
	self.Moving = false;

	self.MouseDown = function(sender, args)
		self:SetBackground("K1R4D3L/KillTracker/Resources/logo_down.tga");
		self.MoveX = args.X;
		self.MoveY = args.Y;
	end

	self.MouseUp = function(sender, args)
		self:SetBackground("K1R4D3L/KillTracker/Resources/logo_up.tga");
		self.MoveX  =-1;
		self.MoveY = 0;
	end

	self.MouseEnter = function(sender, args)
		self:SetOpacity(1);
	end

	self.MouseLeave = function(sender, args)
		self:SetOpacity(.3);
	end

	self.MouseMove = function(sender, args)
		if ((self.MoveX ~= -1) and ((args.X ~= self.MoveX) or (args.Y ~= self.MoveY))) then
			self:SetBackground("K1R4D3L/KillTracker/Resources/logo_move.tga");
			self.Moving = true;

			local newLeft = self:GetLeft() - (self.MoveX - args.X)
			local newTop = self:GetTop() - (self.MoveY - args.Y)

			if (newLeft < 0) then
				newLeft = 0;
			end

			if (newLeft > (Turbine.UI.Display.GetWidth() - 32)) then
				newLeft = Turbine.UI.Display.GetWidth() - 32;
			end
			
			if (newTop < 0) then
				newTop = 0;
			end
			
			if (newTop > (Turbine.UI.Display.GetHeight() - 32)) then
				newTop = Turbine.UI.Display.GetHeight() - 32;
			end

			self:SetPosition(newLeft, newTop);
			
			self:SaveState();
		end
	end
end       

function MinimizedWindow:SaveState()
   -- does nothing, override in instance if desired
end